//Melee shotgun - left click for normal fire, right click for melee
//Made by Cruxeis, BL_ID 35041

addDamageType("meleeShotgun", '%1 <bitmap:Add-Ons/Weapon_MeleeShotgun/CI_meleeShotgun>', '%2 <bitmap:Add-Ons/Weapon_MeleeShotgun/CI_meleeShotgun> %1', 0.75, 1);
addDamageType("meleeShotgunMel", '%1 <bitmap:Add-Ons/Weapon_MeleeShotgun/CI_meleeShotgunMel>', '%2 <bitmap:Add-Ons/Weapon_MeleeShotgun/CI_meleeShotgunMel> %1', 0.75, 1);

datablock projectileData(meleeShotgunMelProjectile)
{
	directDamage		= 10;
	directDamageType	= $DamageType::meleeShotgunMel;
	radiusDamageType	= $DamageType::meleeShotgunMel;
	hasLight			= false;
	lifetime			= 100;
	lightColor			= "0 0 0";
	lightRadius			= 1;
	muzzleVelocity		= 10;
	uiName				= "Melee Shotgun Mel Projectile";
	velInheritFactor	= 1;
};

datablock projectileData(meleeShotgunProjectile : gunProjectile)
{
	directDamage = 15;
	directDamageType = $DamageType::meleeShotgun;
	radiusDamageType = $DamageType::meleeShotgun;
};

datablock itemData(meleeShotgunItem)
{
	canDrop				= true;
	category			= "Item";
	colorShiftColor		= "1 1 1 1";
	density				= 0.2;
	doColorShift		= false;
	elasticity			= 0.2;
	emap				= true;
	equipment			= true;
	friction			= 0.2;
	iconName			= "./meleeShotgunIcon";
	image				= meleeShotgunImage;
	mass				= 1;
	shapeFile			= "./meleeShotgun.dts";
	uiName				= "Melee Shotgun";
};

datablock shapeBaseImageData(meleeShotgunImage)
{
	ammo				= " ";
	armReady	 		= true;
	className 			= "WeaponImage";
	colorShiftColor		= "1 1 1 1";
	correctMuzzleVector = true;
	doColorShift		= false;
	doRetraction		= false;
	emap				= true;
	eyeOffset			= "0 0 0";
	firstPerson			= true;
	hasLight			= true;
	item				= meleeShotgunItem;
	lightColor			= "1 1 1";
	lightRadius			= 0;
	lightType			= "NoLight";
	melee				= false;
	minShotTime			= 750;
	mountPoint			= 0;
	offset				= "0 0 0";
	Projectile			= meleeShotgunProjectile;
	projectileType		= Projectile;
	rotation			= eulerToMatrix("0 0 0");
	shapeFile			= "./meleeShotgun.dts";

	stateName[0]					= "Activate";
	stateTransitionOnTimeout[0]		= "Ready";
	stateSound[0]					= weaponSwitchSound;
	stateTimeoutValue[0]			= 0.01;

	stateName[1]					= "Ready";
	stateTransitionOnTriggerDown[1]	= "Fire";
	stateScript[1]					= "onReady";
	stateAllowImageChange[1]		= true;

	stateName[2]					= "Fire";
	stateTransitionOnTimeout[2]		= "Reload";
	stateScript[2]					= "onFire";
	stateAllowImageChange[2]		= false;
	stateWaitForTimeout[2]			= true;
	stateFire[2]					= true;
	stateTimeoutValue[2]			= 0.01;

	stateName[3]					= "Reload";
	stateTransitionOnTimeout[3]		= "Ready";
	stateScript[3]					= "onReload";
	stateAllowImageChange[3]		= true;
	stateTimeoutValue[3]			= 0.01;
};

function meleeShotgunImage::onFire(%this, %obj, %slot)
{
	if(getSimTime() < (%obj.lastMeleeShotgunTime + %this.minShotTime))
		return;
	%obj.lastMeleeShotgunTime = getSimTime();
	if(%obj.getDamagePercent() <= 1.0)
		%obj.playThread(2, shiftAway);
	serverPlay3D(gunShot1Sound, %obj.getPosition());
	%proj = %this.projectile;
	for(%i = 0; %i < 10; %i++)
	{
		%vec = %obj.getMuzzleVector(%slot);
		%objvel = %obj.getVelocity();
		%mastervel = VectorAdd(VectorScale(%vec, %proj.muzzleVelocity), VectorScale(%objvel, %proj.velInheritFactor));
		%x = ((getRandom() - 0.5) * ($pi / 100));
		%y = ((getRandom() - 0.5) * ($pi / 100));
		%z = ((getRandom() - 0.5) * ($pi / 100));
		%mastervel = MatrixMulVector(MatrixCreateFromEuler(%x SPC %y SPC %z), %mastervel);
		%a = new Projectile()
		{
			client = %obj.client;
			datablock = %proj;
			initialPosition = %obj.getMuzzlePoint(%slot);
			initialVelocity = %mastervel;
			sourceObject = %obj;
			sourceSlot = %slot;
		};
		missionCleanup.add(%a);
	}
	parent::onFire(%this, %obj, %slot);
}

package meleeShotgun {

function Armor::onTrigger(%this, %obj, %slot, %val)
{
	Parent::onTrigger(%this, %obj, %slot, %val);
	if(%obj.getMountedImage(0) == nameToID(meleeShotgunImage) && %slot == 4 && %val)
	{
		if(getSimTime() < (%obj.lastMeleeShotgunMeleeTime + 500))
			return;
		%obj.lastMeleeShotgunMeleeTime = getSimTime();
		%obj.playThread(2, spearThrow);
		%start = %obj.getEyePoint();
		%end = VectorAdd(%start, VectorScale(%obj.getEyeVector(), 10));
		%result = ContainerRayCast(%start, %end, $TypeMasks::PlayerObjectType, %obj);
		if(isObject(firstWord(%result)) && %result.getDamagePercent() <=1.0 && getMinigameFromObject(%obj) == getMinigameFromObject(%result) && isObject(getMinigameFromObject(%obj)))
			%result.damage(%obj.client, %result.getPosition(), meleeShotgunMelProjectile.directDamage , meleeShotgunMelProjectile.directDamageType);
	}
}

};

activatePackage(meleeShotgun);
		
		
		
		
		
		
		
		
		
		
		
		